// Curvy2Doc.h : interface of the CCurvy2Doc class
//

#pragma once

#include "Curve.h"
#include <vector>
using namespace std;

class CCurvy2Doc : public CDocument
{
protected: // create from serialization only
	CCurvy2Doc();
	DECLARE_DYNCREATE(CCurvy2Doc)

// Attributes
public:

// Operations
public:

// Overrides
public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();

// Implementation
public:
	virtual ~CCurvy2Doc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
private:
	vector<CCurve*> m_curves;
public:
	void AddCurve(CCurve* newCurve);
	void RemoveCurve(CCurve* curve);

	unsigned int GetNumCurves(void) const
	{
		return static_cast<unsigned int>(m_curves.size());
	}
	CCurve* GetCurve(unsigned int nIdx) const
	{
		ASSERT(nIdx < GetNumCurves());
		return m_curves[nIdx];
	}

	CCurve* AddNewCurve(void)
	{
		CCurve* newCurve = new CCurve();
		m_curves.push_back(newCurve);
		UpdateAllViews(NULL);
		return newCurve;
	}
	CCurve* GetClosestCurve(CPoint& point);
	bool SelectControlPoint(CCurve* curve, CPoint& point);
private:
	CLIPFORMAT m_clipboardFormat;
public:

	CLIPFORMAT GetClipFormat(void)
	{
		return m_clipboardFormat;
	}
	afx_msg void OnEditCopy();
	afx_msg void OnEditCut();
	afx_msg void OnEditPaste();
	HANDLE CreateClipboardFormatCurvy(CCurve* curve, bool bNormalize = true);
	HANDLE CreateClipboardFormatBitmap(CCurve* curve, bool bNormalize = true);
	CCurve* CreateCurveFromHandle(HANDLE hData);
private:
	
	CCurve* m_selectedCurve;
	int m_nCurrentControlPoint;
public:

	CCurve* GetSelectedCurve(void)
	{
		return m_selectedCurve;
	}
	CCurve* SelectCurve(CPoint& point);

	CCurve* SelectCurve(CCurve* curve)
	{
		m_selectedCurve = curve;
		return m_selectedCurve;
	}
	void MoveSelectedControlPoint(CPoint& diff);
};


