// Curvy2View.h : interface of the CCurvy2View class
//


#pragma once
#include "atltypes.h"


class CCurvy2View : public CView
{
	
protected: // create from serialization only
	CCurvy2View();
	DECLARE_DYNCREATE(CCurvy2View)

// Attributes
public:
	CCurvy2Doc* GetDocument() const;

// Operations
public:

// Overrides
public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);

// Implementation
public:
	virtual ~CCurvy2View();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	DECLARE_MESSAGE_MAP()
private:
	bool m_bDrawing;
	bool m_bReadyToDrag;
	bool m_bDraggingCurve;
	bool m_bDraggingPoint;
	CPoint m_ptOldPoint;
	CPoint m_ptLastMsg;
	CPoint m_ptLastImage;
	CPoint m_ptOffset;
	//int m_nCurrentPoint;
	//CCurve* m_selectedCurve;
	CCurve* m_tempCurve;
	enum CommandMode {Draw, Select};
	CommandMode m_cmCommandMode;
protected:
	void DrawCurves(CDC* pDC, CCurvy2Doc* pDoc);
public:
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnCurvesDraw();
	afx_msg void OnUpdateCurvesDraw(CCmdUI *pCmdUI);
	afx_msg void OnCurvesSelect();
	afx_msg void OnUpdateCurvesSelect(CCmdUI *pCmdUI);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
private:
	COleDropTarget m_oleDropTarget;
public:
//	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	virtual DROPEFFECT OnDragEnter(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual void OnDragLeave();
	virtual DROPEFFECT OnDragOver(COleDataObject* pDataObject, DWORD dwKeyState, CPoint point);
	virtual BOOL OnDrop(COleDataObject* pDataObject, DROPEFFECT dropEffect, CPoint point);
	afx_msg void OnUpdateEditCopy(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditCut(CCmdUI *pCmdUI);
	afx_msg void OnUpdateEditPaste(CCmdUI *pCmdUI);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
};

#ifndef _DEBUG  // debug version in Curvy2View.cpp
inline CCurvy2Doc* CCurvy2View::GetDocument() const
   { return reinterpret_cast<CCurvy2Doc*>(m_pDocument); }
#endif

